## gpsd 3.11

=== SConstruct ===
## SCons build recipe for the GPSD project

# Important targets:
#
# build     - build the software (default)
# dist      - make distribution tarball
# install   - install programs, libraries, and manual pages
# uninstall - undo an install
#
# check     - run regression and unit tests.
# audit     - run code-auditing tools
# testbuild - test-build the code from a tarball
# website   - refresh the website
# release   - ship a release
#
# clean     - clean all normal build targets
# distclean - clean up to a state like a fresh repo pull
#
# Setting the DESTDIR environment variable will prefix the install destinations
# without changing the --prefix prefix.

# Unfinished items:
# * Out-of-directory builds: see http://www.scons.org/wiki/UsingBuildDir
# * Coveraging mode: gcc "-coverage" flag requires a hack for building the python bindings

# Release identification begins here
gpsd_version = "3.11"

# library version
libgps_version_current   = 21
libgps_version_revision  = 0
libgps_version_age       = 0
libgpsd_version_current  = 22
libgpsd_version_revision = 0
libgpsd_version_age      = 0

# Release identification ends here

# Hosting information (mainly used for templating web pages) begins here
# Each variable foo has a corresponding @FOO@ expanded in .in files.
# There are no project-dependent URLs or references to the hosting site
# anywhere else in the distribution; preserve this property!
sitename   = "Savannah"
sitesearch = "catb.org"
website    = "http://catb.org/gpsd" 
mainpage   = "https://savannah.nongnu.org/projects/gpsd/"
webupload  = "login.ibiblio.org:/public/html/catb/gpsd"
cgiupload  = "thyrsus.com:/home/www/thyrsus.com/cgi-bin/"
scpupload  = "dl.sv.nongnu.org:/releases/gpsd/"
mailman    = "http://lists.nongnu.org/mailman/listinfo/"
admin      = "https://savannah.nongnu.org/project/admin/?group=gpsd"
download   = "http://download-mirror.savannah.gnu.org/releases/gpsd/"
bugtracker = "https://savannah.nongnu.org/bugs/?group=gpsd"
browserepo = "http://git.savannah.gnu.org/cgit/gpsd.git"
clonerepo  = "https://savannah.nongnu.org/git/?group=gpsd"
gitrepo    = "git://git.savannah.nongnu.org/gpsd.git"
webform    = "http://www.thyrsus.com/cgi-bin/gps_report.cgi"
formserver = "www@thyrsus.com"
devmail    = "gpsd-dev@lists.nongnu.org"
usermail   = "gpsd-users@lists.nongnu.org"
annmail    = "gpsd-announce@nongnu.org"
ircchan    = "irc://chat.freenode.net/#gpsd"
tiplink    = "<a href='http://gittip.com/esr'>leave a tip at Gittip</a>"
tipwidget  = "<script data-gittip-username='esr' \
	data-gittip-widget='button' src='//gttp.co/v1.js'></script>"
# Hosting information ends here

EnsureSConsVersion(2,0,1)

import copy, os, sys, glob, re, platform, time
from distutils import sysconfig
from distutils.util import get_platform
import SCons

# replacement for functions from the commands module, which is deprecated.
from subprocess import PIPE, STDOUT, Popen
def _getstatusoutput(cmd, input=None, cwd=None, env=None):
    pipe = Popen(cmd, shell=True, cwd=cwd, env=env, stdout=PIPE, stderr=STDOUT)
    (output, errout) = pipe.communicate(input=input)
    status = pipe.returncode
    return (status, output)
def _getoutput(cmd, input=None, cwd=None, env=None):
    return _getstatusoutput(cmd, input, cwd, env)[1]


#
# Build-control options
#

# Start by reading configuration variables from the cache
opts = Variables('.scons-option-cache')

systemd_dir = '/lib/systemd/system'
systemd = os.path.exists(systemd_dir)

# Set distribution-specific defaults here
imloads = True

boolopts = (
    # GPS protocols
    ("nmea",          True,  "NMEA support"),
    ("ashtech",       True,  "Ashtech support"),
    ("earthmate",     True,  "DeLorme EarthMate Zodiac support"),
    ("evermore",      True,  "EverMore binary support"),
    ("fv18",          True,  "San Jose Navigation FV-18 support"),
    ("garmin",        True,  "Garmin kernel driver support"),
    ("garmintxt",     True,  "Garmin Simple Text support"),
    ("geostar",       True,  "Geostar Protocol support"),
    ("itrax",         True,  "iTrax hardware support"),
    ("mtk3301",       True,  "MTK-3301 support"),
    ("navcom",        True,  "Navcom support"),
    ("oncore",        True,  "Motorola OnCore chipset support"),
    ("sirf",          True,  "SiRF chipset support"),
    ("superstar2",    True,  "Novatel SuperStarII chipset support"),
    ("tnt",           True,  "True North Technologies support"),
    ("tripmate",      True,  "DeLorme TripMate support"),
    ("tsip",          True,  "Trimble TSIP support"),
    ("ublox",         True,  "u-blox Protocol support"),
    ("fury",          True,  "Jackson Labs Fury and Firefly support"),
    ("nmea2000",      True,  "NMEA2000/CAN support"),
    # Non-GPS protocols
    ("aivdm",         True,  "AIVDM support"),
    ("gpsclock",      True,  "GPSClock support"),
    ("ntrip",         True,  "NTRIP support"),
    ("oceanserver",   True,  "OceanServer support"),
    ("rtcm104v2",     True,  "rtcm104v2 support"),
    ("rtcm104v3",     True,  "rtcm104v3 support"),
    # Time service
    ("ntpshm",        True,  "NTP time hinting support"),
    ("pps",           True,  "PPS time syncing support"),
    # Export methods
    ("socket_export", True,  "data export over sockets"),
    ("dbus_export",   False, "enable DBUS export support"),
    ("shm_export",    True,  "export via shared memory"),
    # Communication
    ('usb',           True,  "libusb support for USB devices"),
    ("bluez",         True,  "BlueZ support for Bluetooth devices"),
    ("ipv6",          True,  "build IPv6 support"),
    ("netfeed",       True,  "build support for handling TCP/IP data sources"),
    ("passthrough",   True,  "build support for passing through JSON"),
    # Other daemon options
    ("force_global",  False, "force daemon to listen on all addressses"),
    ("timing",        False, "latency timing support"),
    ("control_socket",True,  "control socket for hotplug notifications"),
    ("systemd",       systemd, "systemd socket activation"),
    # Client-side options
    ("clientdebug",   True,  "client debugging support"),
    ("oldstyle",      True,  "oldstyle (pre-JSON) protocol support"),
    ("libgpsmm",      True,  "build C++ bindings"),
    ("libQgpsmm",     True,  "build QT bindings (deprecated alias)"),
    ("qt",            True,  "build QT bindings"),
    # Daemon options
    ("reconfigure",   True,  "allow gpsd to change device settings"),
    ("controlsend",   True,  "allow gpsctl/gpsmon to change device settings"),
    ("cheapfloats",   True,  "float ops are cheap, compute error estimates"),
    ("squelch",       False, "squelch gpsd_report/gpsd_hexdump to save cpu"),
    ("ncurses",       True,  "build with ncurses"),
    # Build control
    ("shared",        True,  "build shared libraries, not static"),
    ("implicit_link", imloads,"implicit linkage is supported in shared libs"),
    ("python",        True,  "build Python support and modules."),
    ("debug",         False, "include debug information in build"),
    ("profiling",     False, "build with profiling enabled"),
    ("coveraging",    False, "build with code coveraging enabled"),
    ("strip",         True,  "build with stripping of binaries enabled"),
    ("chrpath",       False, "use chrpath to edit library load paths"),
    ("manbuild",      True,  "build help in man and HTML formats"),
    ("leapfetch",     True,  "fetch up-to-date data on leap seconds."),
    )
for (name, default, help) in boolopts:
    opts.Add(BoolVariable(name, help, default))

# Gentoo, Fedora, opensuse systems use uucp for ttyS* and ttyUSB*
if os.path.exists("/etc/gentoo-release"):
   def_group = "uucp"
else:
   def_group = "dialout"

nonboolopts = (
    ("gpsd_user",           "nobody",      "privilege revocation user",),
    ("gpsd_group",          def_group,     "privilege revocation group"),
    ("prefix",              "/usr/local",  "installation directory prefix"),
    ("python_libdir",       sysconfig.get_python_lib(plat_specific=1),
                                           "Python module directory prefix"),
    ("limited_max_clients", 0,             "maximum allowed clients"),
    ("limited_max_devices", 0,             "maximum allowed devices"),
    ("fixed_port_speed",    0,             "fixed serial port speed"),
    ("fixed_stop_bits",     0,             "fixed serial port stop bits"),
    ("target",              "",            "cross-development target"),
    ("sysroot",             "",            "cross-development system root"),
    )

for (name, default, help) in nonboolopts:
    opts.Add(name, help, default)

pathopts = (
    ("sysconfdir",          "etc",           "system configuration directory"),
    ("bindir",              "bin",           "application binaries directory"),
    ("includedir",          "include",       "header file directory"),
    ("libdir",              "lib",           "system libraries"),
    ("sbindir",             "sbin",          "system binaries directory"),
    ("mandir",              "share/man",     "manual pages directory"),
    ("docdir",              "share/doc",     "documents directory"),
    ("udevdir",             "/lib/udev",     "udev rules directory"),
    ("pkgconfig",           "$libdir/pkgconfig", "pkgconfig file directory"),
    )
for (name, default, help) in pathopts:
    opts.Add(PathVariable(name, help, default, PathVariable.PathAccept))


#
# Environment creation
#
import_env = (
    "MACOSX_DEPLOYMENT_TARGET", # Required by MacOSX 10.4 (and probably earlier)
    "DISPLAY",         # Required for dia to run under scons
    "GROUPS",          # Required by gpg
    "HOME",            # Required by gpg
    "LOGNAME",         # LOGNAME is required for the flocktest production.
    'PATH',            # Required for ccache and Coverity scan-build
    'PKG_CONFIG_PATH', # Set .pc file directory in a crossbuild
    'PKG_CONFIG_SYSROOT_DIR', # Pass more environment variables to pkg-config (required for crossbuilds)
    'PKG_CONFIG_LIBDIR',      # Pass more environment variables to pkg-config (required for crossbuilds)
    'STAGING_DIR',     # Required by the OpenWRT and CeroWrt builds.
    'STAGING_PREFIX',  # Required by the OpenWRT and CeroWrt builds.
    )
envs = {}
for var in import_env:
    if var in os.environ:
        envs[var] = os.environ[var]
envs["GPSD_HOME"] = os.getcwd()
envs["LD_LIBRARY_PATH"] = os.getcwd()

env = Environment(tools=["default", "tar", "textfile"], options=opts, ENV=envs)
opts.Save('.scons-option-cache', env)
env.SConsignFile(".sconsign.dblite")

for (name, default, help) in pathopts:
    env[name] = env.subst(env[name])

env['VERSION'] = gpsd_version
env['PYTHON'] = sys.executable

# Set defaults from environment.  Note that scons doesn't cope well
# with multi-word CPPFLAGS/LDFLAGS/SHLINKFLAGS values; you'll have to
# explicitly quote them or (better yet) use the "=" form of GNU option
# settings.
env['STRIP'] = "strip"
env['PKG_CONFIG'] = "pkg-config"
env['CHRPATH'] = 'chrpath'
for i in ["AR", "ARFLAGS", "CCFLAGS", "CFLAGS", "CC", "CXX", "CXXFLAGS", "LINKFLAGS", "STRIP", "PKG_CONFIG", "CHRPATH", "LD", "TAR"]:
    if os.environ.has_key(i):
        j = i
        if i == "LD":
            i = "SHLINK"
        if i in ("CFLAGS", "CCFLAGS", "LINKFLAGS"):
            env.Replace(**{j: Split(os.getenv(i))})
        else:
            env.Replace(**{j: os.getenv(i)})
for flag in ["LDFLAGS", "SHLINKFLAGS", "CPPFLAGS"]:
    if os.environ.has_key(flag):
        env.MergeFlags({flag : [os.getenv(flag)]})


# Keep scan-build options in the environment
for key, value in os.environ.iteritems():
    if key.startswith('CCC_'):
        env.Append(ENV={key:value})

# Placeholder so we can kluge together something like VPATH builds.
# $SRCDIR replaces occurrences for $(srcdir) in the autotools build.
env['SRCDIR'] = '.'

def announce(msg):
    if not env.GetOption("silent"):
        print msg

# We need to define -D_GNU_SOURCE
env.Append(CFLAGS='-D_GNU_SOURCE')

=== debian/changelog ===
gpsd (3.11-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * [dd6bbdf1] avoid prompting due to modified lenny conffiles

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 25 Jan 2015 12:15:44 +0100

gpsd (3.11-2) unstable; urgency=medium

  * [a759614c] Avoid prompting due to modified squeeze conffiles.
    Thanks to Andreas Beckmann (Closes: #774872)

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 08 Jan 2015 21:35:30 +0100

gpsd (3.11-1) unstable; urgency=medium

  * [325d1900] Merge tag 'upstream/3.11'
    Upstream version 3.11
  * [8d86b938] Refreshing patches.
  * [877cbcf3] Update symbols file.

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 10 Sep 2014 21:59:28 +0200

gpsd (3.10+dev3~d6b65b48-4) unstable; urgency=medium

  * [8ae93e0]] Two systemd related changes that were forgotton.
    - do not install the old hotplug wrapper
    - don't forget the @ in gpsdctl@.service.
    Thanks to Jeremy Lainé

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 16 Aug 2014 22:12:33 +0200

gpsd (3.10+dev3~d6b65b48-3) unstable; urgency=medium

  * [95fcff8b] Add patch to fix PPS with large offsets.
    Taken from Fedora.
    Thanks to Miroslav Lichvar <mlichvar@redhat.com>
  * [27452a76] Use the Debian package version as gpsd revision.
  * [aca85fbe] Add full systemd hotplug and gpsd options support.
    gpsdctl.service idea taken from Fedora.
    Default gpsd.service file enhanced to read options from
    /etc/default/gpsd.
    Thanks to Miroslav Lichvar, Eduard Bloch (Closes: #741186)
  * [72a6a4af] Disable hotplugging of ftdi/pl2302 usb<>serial adapters.
    These adapters are too common to hit them with the gpsd hotplug script.
    (Closes: #550964, #696020)
  * [e60cdd47] Remove start/stop options from dh_installinit.
    insserv handles boot ordering these days.
    Thanks to Paul Wise (Closes: #751746)
  * [5ed9e35e] Run dh_systemd_* on the gpsd package only.
    Also start gpsd.service only, not gpsdctl.service.
  * [0e50ca3a] Remove hardening-includes.
    dpkg-buildflags ships the appropriate hardening flags.
  * [631b275e] Listen on ipv4 and ipv6.

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 16 Aug 2014 21:02:49 +0200

=== debian/control ===
Source: gpsd
Section: misc
Priority: optional
Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 8.1.3~),
 python-all-dev (>= 2.6.6-3),
 python-all-dbg (>= 2.6.6-3),
 xsltproc, docbook-xsl, docbook-xml,
 libncurses-dev,
 libusb-1.0-0-dev [!hurd-any],
 libdbus-1-dev, libglib2.0-dev, libdbus-glib-1-dev, makedev,
 libbluetooth-dev [linux-any],
 libqt4-dev,
 lsb-release, bc,
 dpkg-dev (>= 1.15.6),
 scons (>= 2.0.1), chrpath,
 dh-buildinfo,
 pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
 dh-systemd (>= 1.3)
Standards-Version: 3.9.2
Homepage: http://www.catb.org/gpsd/
Vcs-Browser: http://git.recluse.de/?p=debian/pkg-gpsd.git
Vcs-Git: git://git.recluse.de/debian/pkg-gpsd.git
X-Python-Version: >= 2.3

Package: gpsd
Architecture: any
Depends: netbase | systemd-sysv, lsb-base (>= 3.2-13),
 adduser (>= 3.34),
 ${shlibs:Depends}, ${misc:Depends},
 libgps21 (= ${binary:Version})
Recommends: udev [linux-any], ${python:Depends}, python
Breaks: ${gpsd:Breaks}
Suggests: gpsd-clients, dbus
Conflicts: fso-gpsd
Multi-Arch: foreign
Description: Global Positioning System - daemon
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 With gpsd, multiple GPS client applications can share access to devices
 without contention or loss of data. Also, gpsd responds to queries with a
 format that is substantially easier to parse than the different standards
 emitted by GPS devices.

Package: gpsd-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 libgps21 (= ${binary:Version}) | gpsd (= ${binary:Version}) | gpsd-clients (= ${binary:Version}) | python-gps (= ${binary:Version})
Description: Global Positioning System - debugging symbols
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the detached debug symbols for gpsd, gpsd-clients,
 python-gps, and libgps21.

Package: gpsd-clients
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libgps21 (= ${binary:Version}),
 python-gps, python-gtk2, python-cairo, ${python:Depends}
Suggests: gpsd
Conflicts: gps
Breaks: ${python:Breaks}
Description: Global Positioning System - clients
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains auxiliary tools and example clients for monitoring and
 testing gpsd.

Package: python-gps
Architecture: any
Section: python
Replaces: gpsd-clients (<< 2.34.dfsg-1)
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 python (>= 2.6) | python-simplejson
Recommends: gpsd
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Conflicts: python-json
Description: Global Positioning System - Python libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python interface to connect to gpsd, together with
 a module providing a controlled testing environment. It also ships two tools
 which utilize the interface: gpsprof for latency-profiling, and gpsfake to
 simulate a GPS by playing back a logfile.

Package: libgps21
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gpsd
Conflicts: fso-gpsd
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - library
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libgps, a C service library for querying GPS
 devices. It supports both a low-level interface, which communicates
 directly with the device to which the GPS is connected, and a high-level
 interface, which goes through gpsd and is intended for concurrent use by
 several applications.

Package: libgps-dev
Architecture: any
Section: libdevel
Depends: libgps21 (= ${binary:Version}), ${misc:Depends}, pkg-config
Conflicts: gpsd (<< 2.34.dfsg-1)
Description: Global Positioning System - development files
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the header and development files needed to build
 programs and packages using libgps.

Package: libqgpsmm21
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - Qt wrapper for libgps
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

Package: libqgpsmm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, pkg-config,
 libqgpsmm21 (= ${binary:Version}),
 libgps-dev (= ${binary:Version})
Description: Global Positioning System - Qt wrapper for libgps (development)
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

=== debian/rules ===
#!/usr/bin/make -f

#uncomment if debhelper should be verbose
#export DH_VERBOSE=1

DEBIAN_VERSION := $(strip $(shell dpkg-parsechangelog| awk '/Version/{print $$2}'))

LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
LIBGPSD_SONAME := $(strip $(shell grep -E '^libgpsd_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))


LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))

#python versions
PYTHONS := $(shell pyversions -vr)
PYTHON_DEFAULT := $(strip $(shell pyversions -vd))

#debhelper version and settings needed for udev
DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
LSB_RELEASE := $(shell lsb_release -si)
UDEV_BREAKS =

ifeq (Debian,$(strip $(LSB_RELEASE))) ## debian ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.3.15; echo $$?)))
UDEV_BREAKS = 125
endif
else ## not debian ##
ifeq (Ubuntu,$(strip $(LSB_RELEASE))) ## ubuntu ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.0.17ubuntu2; echo $$?)))
UDEV_BREAKS = 136-1
endif
endif ## ubuntu ##
endif ## debian ##


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONSOPTS = \
	prefix=/usr \
	systemd=yes \
	strip=no \
	dbus_export=yes \
	docdir=/usr/share/doc/gpsd \
	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	gpsd_user=gpsd \
	gpsd_group=dialout


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += debug=yes
else
	SCONSOPTS += debug=no
endif

SCONSSTATICOPTS = python=no shared=no


#package names
PACKAGE_GPSD := gpsd
PACKAGE_CLIENTS := gpsd-clients
PACKAGE_LIB := libgps$(LIB_soname)
PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
PACKAGE_LIB_DEV := libgps-dev
PACKAGE_QTLIB_DEV := libqgpsmm-dev
PACKAGE_PY := python-gps
PACKAGE_GPSDDBG := gpsd-dbg


cflags := $(shell dpkg-buildflags --get CFLAGS)
cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)

SCONS_ENV := set -e ;\
		export LDFLAGS="$(ldflags)" ;\
		export CFLAGS="$(cflags)" ;\
		export CXXFLAGS="$(cxxflags)" ;\
		export CPPFLAGS="$(cppflags)";


$(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
	    target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g') ;\
	    sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g;s,LIBGPSDSONAME,$(LIBGPSD_SONAME),g' "$$source" > "$$target" ;\
	done

debian/control: debian/control.in
	if grep -q "Package: libgps$(LIBGPS_SONAME)" debian/control; then \
		touch debian/control ;\
	else \
		rm -f $@ ;\
		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g;s,LIBGPSDSONAME,$(LIBGPSD_SONAME),g' $< > $@ ;\
		if [ -d .git ]; then \
			git add debian/control ;\
			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
		fi ;\
	fi

SConstruct.deb_revision: SConstruct
	if [ ! -f $@ ]; then \
		cp $< $@ ;\
		sed -i '/^revision=/s/%(.*)/%("$(DEBIAN_VERSION)",)/' $< ;\
	fi
	touch $@

build-indep: build
build-arch: build

build: build-stamp build-static-stamp
build-stamp: SConstruct.deb_revision
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS); \
		$(SCONS_ENV) python$${py}-dbg /usr/bin/scons $(SCONSOPTS); \
	    done
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# disable tests on hurd due to weird ipv6 errors
	# http://deb.li/4C46AEAC.7040906@bzed.de
ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))
	-$(SCONS_ENV) /usr/bin/scons check
endif
endif
	# ensure the test tools are built
	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) $(shell grep test_ debian/gpsd-dbg.install | grep -v '\.py' | awk '{print $$1}')
	touch $@

build-static-stamp: SConstruct.deb_revision
	mkdir static_lib
	find . \
	    -mindepth 1 -maxdepth 1 \
	    -name static_lib \
	    -prune \
	    -o -name debian -prune \
	    -o -exec cp -pr {} static_lib \;
	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) distclean ;\
	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) $(SCONSSTATICOPTS) libgps.a
	touch $@

clean: debian/control
	dh_testdir
	dh_testroot
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS) distclean ; \
	    	$(SCONS_ENV) python$${py}-dbg /usr/bin/scons $(SCONSOPTS) distclean ; \
	    done
	# revert revision changes in SConstruct
	if [ -f SConstruct.deb_revision ]; then \
	    mv SConstruct.deb_revision SConstruct; \
	fi
	rm -rf \
	    .sconf_temp \
	    .scons-option-cache \
	    .sconsign.dblite \
	    gps/*.pyc \
	    TROUBLESHOOTING \
	    debian/buildinfo.gz \
	    config.log \
	    static_lib \
	    debian/shlibs.local \
	    leapsecond.pyc \
	    $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_clean

install: install-stamp
install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_testdir
	dh_testroot
	dh_prep
	set -e ;\
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py} /usr/bin/scons install $(SCONSOPTS) ;\
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py}-dbg /usr/bin/scons install $(SCONSOPTS) ;\
	    done
	# install static lib
	cp static_lib/libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp INSTALL TROUBLESHOOTING
	# install systemd files
	mkdir -p debian/tmp/lib/systemd/system
	cp systemd/* debian/tmp/lib/systemd/system
	# fix various manpages
	for i in cgps.1 gegps.1 lcdgps.1 xgps.1 xgpsspeed.1 gpxlogger.1; do \
	    rm -f debian/tmp/usr/share/man/man1/$$i ;\
	    ln -s gps.1 debian/tmp/usr/share/man/man1/$$i ;\
	done
	rm -f debian/tmp/usr/share/man/man3/libQgpsmm.3
	ln -s libgpsmm.3.gz debian/tmp/usr/share/man/man3/libQgpsmm.3.gz
	# remove libgpsd development files - we don't want people to use the internal library
	for i in 	usr/share/man/man3/libgpsd.3 \
	    		usr/lib/$(DEB_HOST_MULTIARCH)/libgpsd.so \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libgpsd.pc ;\
	do \
	    rm debian/tmp/$$i ;\
	done
	# install everything
	dh_install --fail-missing
	# remove rpaths
	find debian -type f -exec file {} \; |\
	    grep ELF |\
	    grep 'dynamically linked' |\
	    sed 's,:.*,,' |\
	    xargs chrpath -d
	touch $@


install-indep: install
install-arch: install

binary: install-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs  NEWS
	dh_installdocs 
	dh_installman 
	dh_installmenu 
	dh_systemd_enable -pgpsd
	dh_installinit
	dh_systemd_start -pgpsd --restart-after-upgrade
	dh_installexamples 
	chmod 755 debian/$(PACKAGE_PY)/usr/lib/python*/*-packages/gps/gps.py
	dh_python2 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
	dh_python2 -pgpsd-dbg usr/lib/gpsd/debug
	dh_python2 -pgpsd-clients /usr/bin
	dh_python2 -pgpsd /lib/udev/
	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
	dh_installudev 
	dh_link 
	dh_strip  --dbg-package=$(PACKAGE_GPSDDBG)
	dh_buildinfo -p$(PACKAGE_GPSDDBG)
	dh_compress 
	dh_fixperms  -Xgpsd.hotplug
	dh_lintian
ifeq (,$(DEB_BUILD_OPTIONS))
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME)  -Xlibgpsd -- -c4
	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME) -- -c1
else
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME) -Xlibgpsd
	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME)
endif
	echo 'libgpsd $(LIBGPSD_SONAME) libgps$(LIBGPS_SONAME)' > debian/shlibs.local
	dh_shlibdeps 
ifneq (,$(UDEV_BREAKS))
	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
endif
	dh_gencontrol 
	dh_installdeb 
	dh_md5sums 
	dh_builddeb 


binary-indep: binary
binary-arch: binary

.PHONY: binary binary-indep binary-arch \
	install install-arch install-indep \
	clean \
	build debian/control
